# by DCL manual
=begin
==AdvancedDCL::Box
==={W[ɂ
BoxW[͔Ot`߂̃W[łB
===p^
:frtype(Fixnum)<UUPACK::UUSFRT>
   g̃C^Cvw肷. ݒ肷鑮 Bar.frame,Box.frame Ŏg.
:frindex(Fixnum)<UUPACK::UUSFRI>
   g̃CCfNXw肷. ݒ肷鑮 Bar.frame,Box.frame Ŏg.
:lineindex(Fixnum)<UUPACK::UUSLNI>
   ܂̃CCfNXw肷. 
:linetype(Fixnum)<UUPACK::UUSLNT>
   ܂̃C^Cvw肷B
:variablerange(Array[2, Float])<UUPACK::UUSIDV>
   Ɨϐ̒`w肷. 
:uref(Float)<UUPACK>
   Box.(x,y)frm, Box.(x,y)tone, Box.(x,y)linëx1, y1 ܂ x2, y2  RUNDEF w肷, p^ uref ̒lw肳ꂽ̂Ƃ݂Ȃ. uref ̏l 0 ł. 
:itpat(Array[2, Fixnum])<UUPACK::UUSARP>
   ̈hg[p^[w肷. Őݒ肷ԍ Diff.tone,Bar.tone,Box.tone Ŏg. 

܂Ãp^̓\bhƂėp邱ƂłBȂ킿ABox.frtypeŃp^frtype̎QƂABox.frtype=Ńp^frtype̕ύXłB

=end

module AdvancedDCL
  module Box
    def param_init
      @param = Parameter.new(Common.param)
      @param.init("frtype", Fixnum, "uusfrt", "uuqfrt", 1, 1)
      @param.init("frindex", Fixnum, "uusfri", "uuqfri", 1, 1)
      @param.init("lineindex", Fixnum, "lineindex", "uuqlni", 3, 1)
      @param.init("linetype", Fixnum, "linetype", "uuqlnt", 3, 1)

      @param.init("variablerange", [2, Float], "variablerange", "variabelrangeget", 3, 3)
      @param.init("uref", Float, "uurset", "uurget", 0, 0)
      @param.init("itpat", [2, Fixnum], "uusarp", "uuqarp", 2, 2)

      @temp_param = @param.dup
      @backup = @param.dup
    end
    
    private :param_init

#------------------- method for parameters----------------------

    def set(key, val)
      @param[key] = val
    end

# by kawanabe
=begin
---Box.set(key, val)
    p^̐ݒsB

    
    * key:p^(String)
    * val:ݒ肷lB^͊ep^QƂ̂ƁB
    gp
        Box.set("frindex", 3)      # g̃CCfNX3ɐݒ肷

=end

    def get(key)
      @param[key]
    end

# by kawanabe
=begin
---Box.get(key)
    p^QƂB

    
    * key:p^(String)
    gp
        Bar.gox("frindex")      #g̃CCfNXQƂ

=end

#------------ draw method ----------------------

    def yfrm(x1, x2, y, temp=nil)
      rundef = Fig.rundef
      if(x1.is_a?(NArray))
	x1max = x1.max.to_f
	x1min = x1.min.to_f
      elsif(x1.is_a?(Array))
	x1max = x1[-1].to_f
	x1min = x1[0].to_f
      end
      if(x2.is_a?(NArray))
	x2max = x2.max.to_f
	x2min = x2.min.to_f
      else(x2.is_a?(Array))
	x2max = x2[-1].to_f
	x2min = x2[0].to_f
      end
      if(x1==rundef || x2==rundef)
	x = rundef
      else
	x=Array.new(2)
	if(x1min<x2min)
	  x[0]=x1min
	else
	  x[0]=x2min
	end
	if(x1max>x2max)
	  x[1]=x1max
	else
	  x[1]=x2max
	end
      end
      Basics.checkundef(x, y)
      
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.settrf

      DCL.uhbxf(x1.length, x1, x2, y)
      @backup.sync
      @temp_param.clear
    end

# by DCL manual (modified a little)
=begin
---Box.yfrm(x1, x2, y, temp=nil)
    YƗϐƂ锠Ot̘g`.

    
    * x1, x2 (Array or NArray) : ̗[̍Wl.
    * y (Array or NArray) : Ɨϐ.
    * temp: e|p^(Hash)

    l
    (1)̃\bhUHBXFĂłB
    (2)y RUNDEF w肷, p^variablerangeŎw肵`(x1.length)_ w肳ꂽ̂Ƃ݂Ȃ. `悪w肳ĂȂ, EChEŜ`Ƃ. 
    (3)x1܂ x2 RUNDEF w肷, p^ uref ̒lw肳ꂽ̂Ƃ݂Ȃ. uref ̏l 0 ł. 
    (4)g̑̓p^frtype, frindexŎw肷. 

=end 

    def xfrm(x, y1, y2, temp=nil)
      rundef = Fig.rundef
      if(y1.is_a?(NArray))
	y1max = y1.max.to_f
	y1min = y1.min.to_f
      elsif(y1.is_a?(Array))
	y1max = y1[-1].to_f
	y1min = y1[0].to_f
      end
      if(y2.is_a?(NArray))
	y2max = y2.max.to_f
	y2min = y2.min.to_f
      elsif(y2.is_a?(Array))
	y2max = y2[-1].to_f
	y2min = y2[0].to_f
      end
      if(y1==rundef || y2==rundef)
	y = rundef
      else
	y=Array.new(2)
	if(y1min<y2min)
	  y[0]=y1min
	else
	  y[0]=y2min
	end
	if(y1max>y2max)
	  y[1]=y1max
	else
	  y[1]=y2max
	end
      end
      Basics.checkundef(x, y)
      
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.settrf

      DCL.uvbxf(x.length, x, y1, y2)
      
      @backup.sync
      @temp_param.clear
    end

# by DCL manual (modified a little)
=begin
---Box.xfrm(x, y1, y2, temp=nil)
    XƗϐƂ锠Ot̘g`.

    
    * y1, y2 (Array or NArray) : ̗[̍Wl.
    * x (Array or NArray) : Ɨϐ.
    * temp: e|p^(Hash)

    l
    (1)̃\bhUVBXFĂłB
    (2)x RUNDEF w肷, p^variablerangeŎw肵`(y1.length)_ w肳ꂽ̂Ƃ݂Ȃ. `悪w肳ĂȂ, EChEŜ`Ƃ. 
    (3)y1܂ y2 RUNDEF w肷, p^ uref ̒lw肳ꂽ̂Ƃ݂Ȃ. uref ̏l 0 ł. 
    (4)g̑̓p^frtype, frindexŎw肷. 

=end 
        
    def ytone(x1, x2, y, temp=nil)
      rundef = Fig.rundef
      if(x1.is_a?(NArray))
	x1max = x1.max.to_f
	x1min = x1.min.to_f
      elsif(x1.is_a?(Array))
	x1max = x1[-1].to_f
	x1min = x1[0].to_f
      end
      if(x2.is_a?(NArray))
	x2max = x2.max.to_f
	x2min = x2.min.to_f
      elsif(x2.is_a?(Array))
	x2max = x2[-1].to_f
	x2min = x2[0].to_f
      end
      if(x1==rundef || x2==rundef)
	x = rundef
      else
	x=Array.new(2)
	if(x1min<x2min)
	  x[0]=x1min
	else
	  x[0]=x2min
	end
	if(x1max>x2max)
	  x[1]=x1max
	else
	  x[1]=x2max
	end
      end
      Basics.checkundef(x, y)
      
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.settrf

      DCL.uhbxa(x1.length, x1, x2, y)
      @backup.sync
      @temp_param.clear
    end

# by DCL manual (modified a little)
=begin
---Box.ytone(x1, x2, y, temp=nil)
    Ot̓̈h.

    
    * x1, x2 (Array or NArray) : ̗[̍Wl.
    * y (Array or NArray) : Ɨϐ.
    * temp: e|p^(Hash)

    l
    (1)̃\bhUVBXAĂłB
    (2)y RUNDEF w肷, p^variablerangeŎw肵`(x1.length)_ w肳ꂽ̂Ƃ݂Ȃ. `悪w肳ĂȂ, EChEŜ`Ƃ. 
    (3)x1܂ x2 RUNDEF w肷, p^ uref ̒lw肳ꂽ̂Ƃ݂Ȃ. uref ̏l 0 ł. 
    (4)g[p^[̓p^tpatw肷. 

=end 

    def xtone(x, y1, y2, temp=nil)
      rundef = Fig.rundef
      if(y1.is_a?(NArray))
	y1max = y1.max.to_f
	y1min = y1.min.to_f
      elsif(y1.is_a?(Array))
	y1max = y1[-1].to_f
	y1min = y1[0].to_f
      end
      if(y2.is_a?(NArray))
	y2max = y2.max.to_f
	y2min = y2.min.to_f
      elsif(y2.is_a?(Array))
	y2max = y2[-1].to_f
	y2min = y2[0].to_f
      end
      if(y1==rundef || y2==rundef)
	y = rundef
      else
	y=Array.new(2)
	if(y1min<y2min)
	  y[0]=y1min
	else
	  y[0]=y2min
	end
	if(y1max>y2max)
	  y[1]=y1max
	else
	  y[1]=y2max
	end
      end
      Basics.checkundef(x, y)

      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.settrf

      DCL.uvbxa(x.length, x, y1, y2)
      
      @backup.sync
      @temp_param.clear
    end

# by DCL manual (modified a little)
=begin
---Box.xtone(x, y1, y2, temp=nil)
    Ot̓̈h.

    
    * y1, y2 (Array or NArray) : ̗[̍Wl.
    * x (Array or NArray) : Ɨϐ.
    * temp: e|p^(Hash)

    l
    (1)̃\bhUHBXAĂłB
    (2)x RUNDEF w肷, p^variablerangeŎw肵`(y1.length)_ w肳ꂽ̂Ƃ݂Ȃ. `悪w肳ĂȂ, EChEŜ`Ƃ. 
    (3)y1܂ y2 RUNDEF w肷, p^ uref ̒lw肳ꂽ̂Ƃ݂Ȃ. uref ̏l 0 ł. 
    (4)g[p^[̓p^tpatw肷. 

=end 

    def yline(xd, y, temp=nil)
      Basics.checkundef(xd, y)

      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.settrf

      DCL.uhbxl(xd.length, xd, y)
      @backup.sync
      @temp_param.clear
    end

# by DCL manual (modified a little)
=begin
---Box.yline(xd, y, temp=nil)
    OtŌ.  

    
    * xd (Array or NArray) : ̒[̒l.
    * y (Array or NArray) : Ɨϐ.
    * temp: e|p^(Hash)

    l
    (1)̃\bhUVBXLĂłB
    (2)y RUNDEF w肷, p^variablerangeŎw肵`(x1.length)_ w肳ꂽ̂Ƃ݂Ȃ. `悪w肳ĂȂ, EChEŜ`Ƃ. 
    (3)xd RUNDEF w肷, p^ uref ̒lw肳ꂽ̂Ƃ݂Ȃ. uref ̏l 0 ł. 
    (4)̑̓p^linetype, lineindexŎw肷. 

=end 

    def xline(x, yd, temp=nil)
      rundef = Fig.rundef
      Basics.checkundef(x, yd)

      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.settrf
      if(x==rundef)
	DCL.uvbxl(yd.length, x, yd)
      elsif(yd==rundef)
	DCL.uvbxl(x.length, x, yd)
      else
	DCL.uvbxl(x.length, x, yd)
      end
      
      @backup.sync
      @temp_param.clear
    end

# by DCL manual (modified a little)
=begin
---Box.xline(x, yd, temp=nil)
    OtŌ.

    
    * yd (Array or NArray) : ̒[̒l.
    * x (Array or NArray) : Ɨϐ.
    * temp: e|p^(Hash)

    l
    (1)̃\bhUHBXLĂłB
    (2)x RUNDEF w肷, p^variablerangeŎw肵`(y1.length)_ w肳ꂽ̂Ƃ݂Ȃ. `悪w肳ĂȂ, EChEŜ`Ƃ. 
    (3)yd RUNDEF w肷, p^ uref ̒lw肳ꂽ̂Ƃ݂Ȃ. uref ̏l 0 ł. 
    (4)̑̓p^linetype, lineindexŎw肷. 

=end 

    module_function :param_init
    module_function :set
    module_function :get
    module_function :xfrm
    module_function :yfrm
    module_function :xtone
    module_function :ytone
    module_function :xline
    module_function :yline
    
    param_init
    
#----------------------------------------------------------

    def @param.lineindex(index)
      DCL.uuslni(index)
      DCL.sgspli(index)
    end

    def @temp_param.lineindex(index)
      DCL.uuslni(index)
      DCL.sgspli(index)
    end

    def @backup.lineindex(index)
      DCL.uuslni(index)
      DCL.sgspli(index)
    end

    def @param.linetype(type)
      DCL.uuslnt(type)
      DCL.sgsplt(type)
    end

    def @temp_param.linetype(type)
      DCL.uuslnt(type)
      DCL.sgsplt(type)
    end

    def @backup.linetype(type)
      DCL.uuslnt(type)
      DCL.sgsplt(type)
    end

    def @param.variablerange(range)
      if(range[0]<range[1])
	DCL.uusidv(range[0], range[1])
      else
	DCL.uusidv(range[1], range[0])
      end
    end

    def @temp_param.variablerange(range)
      if(range[0]<range[1])
	DCL.uusidv(range[0], range[1])
      else
	DCL.uusidv(range[1], range[0])
      end
    end

    def @backup.variablerange(range)
      if(range[0]<range[1])
	DCL.uusidv(range[0], range[1])
      else
	DCL.uusidv(range[1], range[0])
      end
    end

    def @backup.variablerange
      DCL.uuqidv
    end

    @param.keys.each{|i|
      eval "def #{i}; @param['#{i}']; end"
      eval "def #{i}=(val); set('#{i}', val); end"
    }
  
    @param.keys.each{|i|
      eval "module_function :#{i}"
      eval "module_function :#{i}="
    }
  end
end
